//
// Created by martin on 30.08.19.
//

#define _USE_MATH_DEFINES

#include <vector>
#include <cmath>
#include "coordinates.h"

namespace lib4neuro::coordinates {
    double degrees_to_radians(double degrees) {
        return degrees * M_PI / 180.0;
    }

    std::vector<std::vector<double>> to_3d_cartesian(double dist1, double dist2, double angle) {
        std::vector<double> a1, a2, a3;

        a1 = {0, 0, 0};
        a2 = {dist1, 0, 0};

        double a1_center_dist = dist1/2;
        double x = 3 * std::cos(degrees_to_radians(angle));
        double y = 3 * std::sin(degrees_to_radians(angle));
        a3 = {a1_center_dist - x, y, 0};
        if(angle > 90) {
            a3.at(0) = a1_center_dist + x;
        }

        std::vector<std::vector<double>> v = {a1, a2, a3};
        return v;
    }
}
