//
// Created by martin on 30.08.19.
//

#ifndef LIB4NEURO_COORDINATES_H
#define LIB4NEURO_COORDINATES_H

#include <vector>

namespace lib4neuro::coordinates {

    /**
     * Function transforming internal coordinates of 3-atomic system to Cartesian coordinates.
     *
     * @param dist1 Distance between two of the atoms A1, A2
     * @param dist2 Distance between the third atom A3 and the centre C between the atoms A1 and A2
     * @param angle Angle A1 - C - A3 in degrees
     * @return Cartesian coordinates of the 3-atomic system in the format <A1, A2, A3>
     */
    std::vector<std::vector<double>> to_3d_cartesian(double dist1, double dist2, double angle);

    double degrees_to_radians(double degrees);
}

#endif //LIB4NEURO_COORDINATES_H
