
#ifndef LIB4NEURO_CROSSVALIDATOR_H
#define LIB4NEURO_CROSSVALIDATOR_H

#include "../settings.h"
#include "../DataSet/DataSet.h"
#include "../LearningMethods/LearningMethod.h"

namespace lib4neuro {

    /**
     *
     */
    class CrossValidator {
    private:

        /**
         *
         */
        LearningMethod* optimizer;

        /**
         *
         */
        ErrorFunction* ef;

    public:

        /**
         *
         * @param optimizer
         * @param data_set
         */
        LIB4NEURO_API CrossValidator(LearningMethod* optimizer,
                                     ErrorFunction* ef);

        /**
         *
         * @param k
         * @param test_number
         * @param results_file_path
         */
        LIB4NEURO_API void
        run_k_fold_test(unsigned int k,
                        unsigned int test_number,
                        std::string results_file_path = "");

        /**
         *
         * @param k
         * @param tests_number
         * @param results_file_path
         */
        LIB4NEURO_API void run_k_fold_test(unsigned int k,
                                           unsigned int tests_number,
                                           std::ofstream* results_file_path);
    };
}

#endif //LIB4NEURO_CROSSVALIDATOR_H
