
#include "Neuron.h"
#include "NeuronBiased.h"

#ifndef LIB4NEURO_NEURONFILTER_H
#define LIB4NEURO_NEURONFILTER_H

namespace lib4neuro {

    /**
     * Filter linear unit neuron class - uses activation function in the form f(x) = max(0, x),
     * 'x' being the neuron's potential
     */
    class NeuronFilter : public NeuronBiased {
    public:
        struct access;

        LIB4NEURO_API explicit NeuronFilter(double b = 0.0);

        LIB4NEURO_API double activate(double x,
                                      double b) override;

        LIB4NEURO_API double activation_function_eval_derivative_bias(double x,
                                                                      double b) override;

        LIB4NEURO_API double activation_function_eval_derivative(double x,
                                                                 double b) override;

        LIB4NEURO_API Neuron* get_derivative() override;
    };
}

#endif //LIB4NEURO_NEURONFilter_H
