
#include "Neuron.h"

#ifndef INC_4NEURO_NEURONLINEARSATURATED_H
#define INC_4NEURO_NEURONLINEARSATURATED_H

namespace lib4neuro {

    /**
     * LinearSaturated linear unit neuron class 
     * 
     */
    class NeuronLinearSaturated : public NeuronDifferentiable {
	
	protected:
		double saturation_point;
	
	public:
        struct access;

        LIB4NEURO_API explicit NeuronLinearSaturated(double saturation_point = 0.0);

        LIB4NEURO_API double activate(double x,
                                      double b) override;

        LIB4NEURO_API double activation_function_eval_derivative_bias(double x,
                                                                      double b) override;

        LIB4NEURO_API double activation_function_eval_derivative(double x,
                                                                 double b) override;

        LIB4NEURO_API Neuron* get_derivative() override;
    };
}

#endif //INC_4NEURO_NEURONLINEARSATURATED_H
