
#ifndef LIB4NEURO_CSVREADER_H
#define LIB4NEURO_CSVREADER_H

#include <string>

#include "../settings.h"
#include "../DataSet/DataSet.h"
#include "Reader.h"

namespace lib4neuro {

    /**
     *
     */
    class CSVReader : public Reader {
        //TODO make more efficient - possibly with external library?

    protected:

        /**
         *
         */
        bool header_included;

        /**
         *
         */
        std::string delimiter;

//        /**
//         *
//         */
//        bool ignore_first_line;

    public:
        /**
         *
         * @param file_path
         * @param delimiter
         * @param ignore_first_line
         */
        LIB4NEURO_API CSVReader(std::string file_path,
                                std::string delimiter = ",",
                                bool ignore_first_line = false);

        /**
         *
         * @param input_col_indices
         * @param output_col_indices
         * @return
         */
        LIB4NEURO_API [[nodiscard]] std::shared_ptr<DataSet> get_data_set(std::vector<unsigned int>* input_col_indices,
                                                                          std::vector<unsigned int>* output_col_indices);
    };
}

#endif //LIB4NEURO_CSVREADER_H
