//
// Created by martin on 16.08.19.
//

#ifndef LIB4NEURO_READER_H
#define LIB4NEURO_READER_H


#include <string>
#include <vector>
#include <memory>
#include <algorithm>

#include "../settings.h"
// #include "../exceptions.h"
#include "../DataSet/DataSet.h"

namespace lib4neuro {
    class Reader {
    protected:

        /**
         *
         */
        std::string file_path;

        /**
         *
         */
        std::vector<std::vector<std::string>> data;

        /**
         *
         */
        bool ignore_first_line;

        /**
         *
         */
        std::string delimiter;

        /**
         *
         */
        std::shared_ptr<DataSet> data_set;

        void remove_white_characters_from_vector(std::vector<std::string>& v);

    public:
        LIB4NEURO_API explicit Reader(const std::string& file_path, bool ignore_first_line, std::string delimiter);

        /**
         *
         */
        LIB4NEURO_API virtual void read();

        /**
         *
         * @return
         */
        LIB4NEURO_API std::vector<std::vector<std::string>>* get_data();

//        /**
//         *
//         * @param input_col_indices
//         * @param output_col_indices
//         * @return
//         */
//        LIB4NEURO_API virtual std::shared_ptr<DataSet> get_data_set(std::vector<unsigned int>* input_col_indices,
//                                                                    std::vector<unsigned int>* output_col_indices) = 0;

        /**
         *
         */
        LIB4NEURO_API void print_data();
    };
}

#endif //LIB4NEURO_READER_H
