//
// Created by martin on 10.09.19.
//

#ifndef LIB4NEURO_ACSFPARAMETERSOPTIMIZER_H
#define LIB4NEURO_ACSFPARAMETERSOPTIMIZER_H

#include "../settings.h"
#include "../ErrorFunction/ErrorFunctions.h"
#include "../SymmetryFunction/SymmetryFunction.h"
#include "../Network/ACSFNeuralNetwork.h"

namespace lib4neuro {
    class ACSFParametersOptimizer {
    private:
        ErrorFunction* error_func;

        ACSFNeuralNetwork* net;

        DataSet* data_set;

        XYZReader* reader;  // TODO implement for Reader class in general

    public:
        LIB4NEURO_API explicit ACSFParametersOptimizer(ErrorFunction* ef, XYZReader* reader);

        LIB4NEURO_API void fit_ACSF_parameters(std::vector<SYMMETRY_FUNCTION_PARAMETER>& fitted_params,
                                               bool random_init_params);

        LIB4NEURO_API void fit_ACSF_parameters(std::vector<SYMMETRY_FUNCTION_PARAMETER>& fitted_params,
                                               bool random_init_params,
                                               unsigned int main_iterations_num,
                                               unsigned int steady_temperature_iters_num,
                                               double init_temperature,
                                               double temperature_change,
                                               double distribution_stddev,
                                               double termination_threshold);
    };
}

#endif //LIB4NEURO_ACSFPARAMETERSOPTIMIZER_H
