//
// Created by martin on 12.08.19.
//

#ifndef LIB4NEURO_ELEMENT_H
#define LIB4NEURO_ELEMENT_H

#include <string>
#include <vector>

#include "../settings.h"
#include "../SymmetryFunction/SymmetryFunction.h"
#include "../Neuron/Neuron.h"

namespace lib4neuro {
    class Element {
    public:
        Element();

        LIB4NEURO_API Element(const std::string& element_symbol,
//                              unsigned int n_particles,
                              std::vector<SymmetryFunction*>& symmetry_functions
//                              const std::vector<unsigned int>& n_hidden_neurons,
//                              const std::vector<NEURON_TYPE>& hidden_neuron_types,
//                              bool charge
                              );

        LIB4NEURO_API [[nodiscard]] const std::string& getElementSymbol() const;

//        LIB4NEURO_API [[nodiscard]] unsigned int getNParticles() const;

        LIB4NEURO_API [[nodiscard]] std::vector<SymmetryFunction*>* getSymmetryFunctions();

//        LIB4NEURO_API [[nodiscard]] const std::vector<unsigned int>& getNHiddenNeurons() const;
//
//        LIB4NEURO_API [[nodiscard]] const std::vector<NEURON_TYPE>& getHiddenNeuronTypes() const;
//
//        LIB4NEURO_API [[nodiscard]] bool isCharge() const;

        struct access;

    protected:
        std::string                      element_symbol;
//        unsigned int                     n_particles;
        std::vector<SymmetryFunction*>   symmetry_functions;
//        std::vector<unsigned int>        n_hidden_neurons;
//        std::vector<NEURON_TYPE>         hidden_neuron_types;
//        bool                             charge;
    };
}

#endif //LIB4NEURO_ELEMENT_H
