//
// Created by martin on 14.08.19.
//

#ifndef LIB4NEURO_ELEMENTSERIALIZATION_H
#define LIB4NEURO_ELEMENTSERIALIZATION_H

#include <boost/serialization/base_object.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
#include <boost/serialization/export.hpp>
#include <boost/serialization/vector.hpp>

#include "Element.h"

BOOST_CLASS_EXPORT_KEY(lib4neuro::Element)

struct lib4neuro::Element::access {
    template<class Archive>
    static void serialize(Archive& ar,
                          lib4neuro::Element& e,
                          const unsigned int version) {
        ar & e.element_symbol;
//        ar & e.n_particles;
        ar & e.symmetry_functions;
//        ar & e.n_hidden_neurons;
//        ar & e.hidden_neuron_types;
//        ar & e.charge;
    }
};

namespace boost::serialization {

        /**
         * Serialization function
         * @tparam Archive Boost library template
         * @param ar Boost parameter - filled automatically during serialization!
         * @param e Element instance
         * @param version Boost parameter - filled automatically during serialization!
         */
        template<class Archive>
        void serialize(Archive& ar,
                       lib4neuro::Element& e,
                       const unsigned int version) {
            lib4neuro::Element::access::serialize(ar,
                                                  e,
                                                  version);
        }
} // namespace boost

#endif //LIB4NEURO_ELEMENTSERIALIZATION_H
