
#ifndef PROJECT_MESSAGE_H
#define PROJECT_MESSAGE_H

#include "mpi_wrapper.h"

#include <cassert>
#include <iomanip>
#include <iostream>

#define COL_WIDTH 20
#define R_ALIGN std::setw(COL_WIDTH) << std::right

#define COUT_INFO(inp) if(lib4neuro::mpi_rank == 0) { std::cout << std::flush << std::fixed << std::setprecision(12) << "INFO: " << inp  << std::endl << std::flush; }

#ifdef L4N_DEBUG
#define COUT_DEBUG(inp) if(lib4neuro::mpi_rank == 0) { assert(std::cerr << std::flush << std::fixed << std::setprecision(12) << "DEBUG: " << inp << std::endl << std::flush); }

#define WRITE_TO_OFS_DEBUG(ofs, msg) { if(ofs && ofs->is_open() && lib4neuro::mpi_rank == 0)\
                                           *ofs << std::fixed << std::setprecision(12) << "DEBUG: " << msg;\
                                     }
#else
#define COUT_DEBUG(inp)
#define WRITE_TO_OFS_DEBUG(ofs, msg)
#endif // L4N_DEBUG

#endif //PROJECT_MESSAGE_H
